/* Теоретичні питання
1. Як можна створити рядок у JavaScript?
В JavaScript ви можете створювати рядки, обгортаючи текст одинарними ('), подвійними (") або обертками (`).
Є ще один спосіб створення рядків в JavaScript, це використання конструктора String(). 
Конструктор String() генерує рядок як об'єкт (коли викликається з new). Якщо викликати його як функцію, значення приводиться до примітивного рядка.

2. Яка різниця між одинарними (''), подвійними ("") та зворотніми (``) лапками в JavaScript?
Всі ці лапки обгортають текст в рядок. Але  є різниця зі зворотніми лапками, які мають додатковий функціонал 
(написання шаблонних рядків, перенесення на нові рядки відповідно до перенесень у коді).

3. Як перевірити, чи два рядки рівні між собою?
Порівняння здійснюються за допомогою операторів порівняння та вираховується між ними булевий тип.

4. Що повертає Date.now()?
Метод Date.now() повертає кількість мілісекунд які пройшли з 01.01.1970 до поточного часу.

5. Чим відрізняється Date.now() від new Date()?
На відміну від Date.now(), який повертає кількість мілісекунд, new Date() нам повертає поточну дату (число, місяць, рік, день, широта).


Практичні завдання
1. Перевірити, чи є рядок паліндромом. Створіть функцію isPalindrome, яка приймає рядок str і повертає true, якщо рядок є паліндромом
(читається однаково зліва направо і справа наліво), або false в іншому випадку.
*/

'use strict'

let userPalindrome = prompt('Введіть рядок, який є паліндромом!').toLowerCase();

function isPalindrome (str) {
    return str === str.split('').reverse('').join('');
}
if(isPalindrome(userPalindrome) === true){
    alert('Вітаю, рядок є паліндромом!!!');
}else{
    alert('Нажаль рядок не є паліндромом!!!');
}

/*2. Створіть функцію, яка перевіряє довжину рядка. Вона приймає рядок, який потрібно перевірити, максимальну довжину і повертає true, 
якщо рядок менше або дорівнює вказаній довжині, і false, якщо рядок довший. Ця функція стане в нагоді для валідації форми.
*/

function stringLength(str, maxLength) {
    return str.length <= maxLength;
}

console.log(stringLength('checked string', 20)); 
console.log(stringLength('checked string', 10));
console.log(stringLength('mypassword',8));


/*3. Створіть функцію, яка визначає скільки повних років користувачу. Отримайте дату народження користувача через prompt. 
Функція повина повертати значення повних років на дату виклику функцію.*/


let inputBirthDate = prompt('Будь-ласка введіть дату свого народження у форматі: РРРР/ММ/ДД.');
let userBirthday = new Date(inputBirthDate);

function calculateAge(date) {
    let today = new Date();
    let birthDate = new Date(date);
    let age = today.getFullYear() - birthDate.getFullYear();
    let month = today.getMonth() - birthDate.getMonth();
    if (month < 0 || (month === 0 && today.getDate() < birthDate.getDate())) {
        age--;
    }
    return age;
}
console.log(calculateAge(userBirthday))
